/*
    HID Device Info
*/
#ifndef __HidDInfo_H__
#define __HidDInfo_H__

#include "TsVector.h"

struct HidDInfo_t {
    std::string    path;
    unsigned short vid;
    unsigned short pid;
    unsigned short version;
    void*          handle;

    HidDInfo_t():path(), vid(), pid(), version(), handle(0){}
    HidDInfo_t(const std::string& _path, unsigned short _vid, unsigned short _pid, unsigned short _version, void* _handle = 0)
        :path(_path), vid(_vid), pid(_pid), version(_version), handle(_handle){}
};

typedef akar::TsV<HidDInfo_t, 1> TsVHidDInfo;

TsVHidDInfo HidDEnumerate(int VID, int PID, bool keep_open = false, bool exclusive = false, bool overlapped = false);

#endif /* __HidDInfo_H__ */

