#ifndef __StdSharedPtr_H__
#define __StdSharedPtr_H__

namespace std{

template<class T>
class shared_ptr {
    template<class U>
    friend class shared_ptr;
public:
    shared_ptr() :p(), c() {}
    explicit shared_ptr(T* s) :p(s), c(new unsigned(1)) {}

    shared_ptr(const shared_ptr& s) :p(s.p), c(s.c) { 
        if(c) ++*c; 
    }

    shared_ptr& operator=(const shared_ptr& s) {
        if(this!=&s) { 
            clear(); 
            p=s.p; 
            c=s.c; 
            if(c) ++*c; 
        } 
        return *this; 
    }

    template<class U>
    shared_ptr(const shared_ptr<U>& s) 
        :p(s.p), c(s.c) 
    { 
        if(c) ++*c; 
    }

    ~shared_ptr() { clear(); }

    void clear(){ 
        if(c){
            if(*c==1) delete p; 
            if(!--*c) delete c; 
        } 
        c=0; p=0; 
    }

    T* get() const { return (c)? p: 0; }
    T* operator->() const { return get(); }
    T& operator*() const { return *get(); }

private:
    T* p;
    unsigned* c;
};

}   /* namespace std */
#endif /* __TuSharedPtr_H__ */
