/*
    Shared Vector with Any Dimension
*/
#ifndef __TsVector_H__
#define __TsVector_H__

#if 0
#include "StdSharedPtr.h"
#include <vector>
#else
#include <memory>
#include <vector>
#endif

namespace akar
{
template <typename T, int N>
struct TsV: public std::shared_ptr< std::vector < TsV<T, N-1> > > {
    typedef TsV<T, N-1>                TswType;
    typedef std::vector< TsV<T, N-1> > Tu;

    TsV(Tu* p): std::shared_ptr< Tu > (p) {}
    TsV(): std::shared_ptr<Tu>(new Tu){}


    TswType& operator[] (size_t index) {
        size_t size = get()->size();

        if(index >= size) {
            for(size_t i = size; i != index+1; i++) {
                get()->push_back(TswType::create());
            }
        }
        return(*get())[index];
    }

    TswType operator() (size_t index){
        if(get()) {
            size_t size = get()->size();

            if(index >= size) {
                return TswType(0);
            }else{
                return(*get())[index];
            }
        }else{
            return TswType(0);
        }
    }

    size_t size(void) {
        return get()->size();
    }

    void resize(size_t n) {
        get()->resize(n);
    }

    size_t max_element_size(void){
        size_t max_size = 0;

        for(size_t i=0; i<size(); i++) {
            size_t size = operator[](i)->size();
            if(size > max_size) {
                max_size = size;
            }
        }

        return max_size;
    }

    static TsV create(void){
        return TsV<T, N>(new Tu);
    }

};

template <typename T>
struct TsV<T, 1>: public std::shared_ptr< std::vector<T> > {
    typedef std::vector<T> Tu;

    TsV<T, 1>(Tu* p): std::shared_ptr< Tu > (p) {}
    TsV<T, 1>(): std::shared_ptr< Tu >(new Tu){}

    T& operator [] (size_t index) {
        size_t size = get()->size();

        if(index >= size) {
            for(size_t i = size; i != index+1; i++) {
                get()->push_back(T());
            }
        }
        return(*get())[index];
    }

    bool operator()(size_t index){
        if(get()) {
            size_t size = get()->size();

            if(index >= size) {
                return 0;
            }

            return 1;
        }else{
            return 0;
        }
    }

    size_t size(void) {
        if(get()){
            return get()->size();
        }
        return 0;
    }

    void resize(size_t n) {
        get()->resize(n);
    }

    bool is_defined(size_t index){
        return index < size();
    }

    void add(const T& s){
        get()->push_back(s);
    }

    static TsV<T, 1> create(void){
        return TsV<T, 1>(new Tu);
    }

};

} /* namespace akar */

#endif /* __TsVector_H__ */
