#ifndef __WIIPCEVENTER_H__
#define __WIIPCEVENTER_H__

#include "WiiPCThreadBase.h"
#include "WiiPCCommon.h"

namespace WiiPC{

#define EVENTER_CELL_SIZE   100

struct EventerT : public ThreadBaseT {
    struct cell_t {
        event_id_t       id;
        event_callback_t callback;
        uint32_t         delay;
        uint16_t         m;
        void*            p;
        uint32_t         flags;
        uint32_t         group;
    };

    cell_t               cell[EVENTER_CELL_SIZE];
    uint32_t             n_cell;
    std::recursive_mutex mutex_cell;
    event_id_t           max_id;

    EventerT();
    virtual void func(void);

    event_id_t      set_event   (event_callback_t callback, uint16_t m, void* p, uint32_t delay_ms, uint32_t group = 0);
    bool __ok       cancel_event(event_id_t event_id, uint16_t* pm, void** pp);
    uint32_t __num  cancel_group(uint32_t group, event_callback_t cancel_back = 0);

    void            cal_n_cell  (void);

};

}   /* namespace WiiPC */


#endif /* __WIIPCEVENTER_H__ */
