#ifndef __WIIPCMAPPER_H__
#define __WIIPCMAPPER_H__

#include "WiiPCCommon.h"

namespace WiiPC {

struct MapperT {
    // c: core
    // w: wiipc
    unsigned short c2w[4];
    unsigned short w2c[4];
    unsigned int*  wiimote_sources;
    uint8_t*       conn_bitmap;
    unsigned int   old_wiimote_sources[4];
    uint8_t        old_conn_bitmap;
    bool           is_inited;

    MapperT();

    void    init    (unsigned int _g_wiimote_sources[4], uint8_t* _conn_bitmap);
    void    reset   (void);
    void    remap   (void);
    void    dump    (void);

    uint8_t core_bitmap (void);
    uint8_t wiipc_bitmap(void);

    int num_core_mapped(void);
    int num_wiipc_mapped(void);

    bool __valid wiipc_to_core(int __wiipc index, int* __core  mapped_index);
    bool __valid core_to_wiipc(int __core  index, int* __wiipc mapped_index);

    //int __from_one_but_zero __mapped notify_connected(int __from_zero index);
    //int __from_one_but_zero __mapped notify_disconnected(int __from_zero index);
};


} /* namespace WiiPC */


#endif /* __WIIPCMAPPER_H__ */

