#ifndef __WIIPCREADER_H__
#define __WIIPCREADER_H__

#include "WiiPCThreadBase.h"
#include "QReport.h"
#include "udata.h"
#include "WiiPCCommon.h"

namespace WiiPC {

struct ReaderT: public ThreadBaseT {
    udata_t    udata;
    uevent_t   uevent;

    report_t   d_int[4];

    q_report_t q_ctl[4];
    q_report_t q_int[4];

    void func       (void);
    void on_ucore   (udata_t* d, uevent_t* e);
    void on_info    (uint8_t channel, uint8_t* u);
    void proceed    (udata_t* _udata = 0);
    int  try_read   (DWORD timeout, udata_t* _udata = 0);
    int  read       (DWORD timeout);
    bool feed       (report_t* report, int __core index);
    void reset      (int __core index);
    void reset_all  (void);

    ReaderT();
};


} /* namespace WiiPC */

#endif /* __WIIPCREADER_H__ */
