#include "WiiPCWriter.h"
#include "HpCounter.h"
#include "dconsole.h"

namespace WiiPC {

bool __available WriterT::merge_int(udata_t& U){
    int i;
    report_t R;
    uint8_t alloc[4];
    uint8_t bitmap = 0;
    int     used = 0;        

    if(connected_num() == 1) {
        int j = connected_first_index();
        int n;

        n = q_int[j].size();
        
        if((n >= 4) || (n && q_int_timeout[j] == 0)) {
            for(i=0; i<4; ++i) {
                U.usb_extra_bt.data[i][0] = 0x00;
                alloc[i] = 0;
            }

            if(n > 4 ) {
                n = 4;
            }
                    
            for(i=0; i<n; ++i) {
                if(q_int[j].get(R)) {
                    alloc[i] = j;
                    used++;

                    #if 1
                    // Webb
                    //print Dolphin to wiimote report
                    //dprintf("R[%d] = [",i);
                    //dprintbuf(R.data,22);
                    //dprintf("]\n");
                    #endif

                    memcpy(&(U.usb_extra_bt.data[i][0]), R.data, 22);
                }
            }

            bitmap = ((alloc[0] & 3) << 0) | 
                     ((alloc[1] & 3) << 2) | 
                     ((alloc[2] & 3) << 4) |
                     ((alloc[3] & 3) << 6);

            U.usb_extra_bt.bitmap = bitmap;
            U.usb_extra_bt.usb_report_id = USB_EXTRA_RX_REPORT_ID;
            U.usb_extra_bt.cmd           = udata_usb_extra_cmd_bt_tx;

        }

        return used != 0;
    //Simon 121113
    #if 0
    }else if(connected_num() == 4){
        int j;

        for(i=0;i<4;++i) {
            U.usb_extra_bt.data[i][0] = 0x00;
            alloc[i] = 0;
            #if 0
            //save previous rumble state
            prev_rumble_flag[i] = rumble_flag[i];
            //get rumble state
            q_int[i].get(R);
            if ((R.data[1] % 2) == 1){
                rumble_flag[i] = true;
            }else{
                rumble_flag[i] = false;
            }
            #endif
        }
        
        if (send_finish == true) {
            for(i=0;i<2;++i) {
                if (MapperCoreToWiiPC(i,&j)) {
                    if (q_int[i].get(R)) {
                        alloc[i] = j;
                        used ++;
                        #if 0
                        // try to set all rumble off
                        if (R.data[1] % 2 == 1){
                            R.data[1] = R.data[1] - 1;
                        }
                        #endif
                        #if 0
                        //print wiimotes' output report
                        dprintf("R[%d] = [",i);
                        dprintbuf(R.data,22);
                        dprintf("]\n");
                        #endif
                        memcpy(&(U.usb_extra_bt.data[i][0]), R.data, 22);

                    }
                }
            }
    
            if(used) {
                bitmap = ((alloc[0] & 3) << 0) | 
                         ((alloc[1] & 3) << 2) ;
            
                U.usb_extra_bt.bitmap = bitmap;
                U.usb_extra_bt.usb_report_id = USB_EXTRA_RX_REPORT_ID;
                U.usb_extra_bt.cmd           = udata_usb_extra_cmd_bt_tx;
            }
            send_finish = false;
        }else{
            //for(i=2;i<4;++i) {
            for(i=0;i<2;++i) {
                //if (MapperCoreToWiiPC(i,&j)) {
                if (MapperCoreToWiiPC((i+2),&j)) {
                    //if (q_int[i].get(R)) {
                    if (q_int[(i+2)].get(R)) {
                        alloc[i] = j;
                        used ++;
                        #if 0
                        // try to set all rumble off
                        if (R.data[1] % 2 == 1){
                            R.data[1] = R.data[1] - 1;
                        }
                        #endif
                        memcpy(&(U.usb_extra_bt.data[i][0]), R.data, 22);
                    }
                }
            }
    
            if(used) {
                bitmap = ((alloc[0] & 3) << 0) | 
                         ((alloc[1] & 3) << 2) ;
                         //((alloc[2] & 3) << 4) |
                         //((alloc[3] & 3) << 6);
            
                U.usb_extra_bt.bitmap = bitmap;
                U.usb_extra_bt.usb_report_id = USB_EXTRA_RX_REPORT_ID;
                U.usb_extra_bt.cmd           = udata_usb_extra_cmd_bt_tx;
            }
            send_finish = true;
        }
        
        return used != 0;
    #endif
    //Simon 121113
    }else{
        int j;
        
        for(i=0; i<4; ++i) {
            U.usb_extra_bt.data[i][0] = 0x00;
            alloc[i] = 0;
        }
        
        for(i=0; i<4; ++i) {
            if (MapperCoreToWiiPC(i, &j)) {
                if (q_int[i].get(R)) {
                    alloc[i] = j;
                    used ++;
                    #if 0
                    //Simon 121114 [when 4 wiimote disable rumble]
                    if (connected_num() == 4) {
                            if (R.data[1] % 2 == 1){
                                R.data[1] = R.data[1] - 1;
                        }
                    }
                    //Simon 121114
                    #endif

                    #if 0
                    if (i == 1) {
                        if (R.data[0] == 0x12 && R.data[2] == 0x31) {
                            //_0x34_flag = 1;
                            R.data[0] = 0x12;
                            R.data[2] = 0x34;
                        }
                    }
                    #endif

                    #if 1
                    // Webb
                    //print Dolphin to wiimote report
                    //dprintf("R[%d] = [",i);
                    //dprintbuf(R.data,22);
                    //dprintf("]\n");
                    #endif
                                        
                    memcpy(&(U.usb_extra_bt.data[i][0]), R.data, 22);
                }else{
                    //Simon 121115
                    //connected but no report -> get next wiimote's report
                    #if 0
                    for(int cnt=1;cnt<4;cnt++) {
                        int d =(i+cnt)%4;
                        if(MapperCoreToWiiPC(d,&j)) {
                            if(q_int[d].get(R)) {
                                alloc[i] = j;
                                used++;
                                memcpy(&(U.usb_extra_bt.data[i][0]), R.data, 22);
                                break;
                            }
                        }
                    }
                    #endif
                    //Simon 121115
                }
            }
        }
        
        if(used) {
            bitmap = ((alloc[0] & 3) << 0) | 
                     ((alloc[1] & 3) << 2) | 
                     ((alloc[2] & 3) << 4) |
                     ((alloc[3] & 3) << 6);
        
            U.usb_extra_bt.bitmap = bitmap;
            U.usb_extra_bt.usb_report_id = USB_EXTRA_RX_REPORT_ID;
            U.usb_extra_bt.cmd           = udata_usb_extra_cmd_bt_tx;
        }
        
        return used != 0;
    }
}

#if 0
bool __available WriterT::merge_aud(udata_t& U){
    int i, j, n;
    bool valid = false;
    uint8_t  bitmap;
    uint8_t  alloc[4] = {0};
    report_t R;

    for(i=0; i<4; ++i) {
        n = q_aud[i].size();

        if((n >= 2) || (n && (aud_count[i] == 0))) {
            j = i;
            valid = true;
            break;
        }
    }

    if(valid) {
        if(n > 2) {
            n = 2;
        }

        //dprintf("{%d}", n);
        for(i=0; i<4; ++i) {
            U.usb_extra_bt.data[i][0] = 0x00; 
        }

        for(i=0; i<n; ++i) {
            if(q_aud[j].get(R)) {
                alloc[i] = j;
                memcpy(&(U.usb_extra_bt.data[i][0]), R.data, 22);
            }
        }

        bitmap = ((alloc[0] & 3) << 0) | 
                 ((alloc[1] & 3) << 2) | 
                 ((alloc[2] & 3) << 4) |
                 ((alloc[3] & 3) << 6);

        U.usb_extra_bt.bitmap        = bitmap;
        U.usb_extra_bt.usb_report_id = USB_EXTRA_RX_REPORT_ID;
        U.usb_extra_bt.cmd           = udata_usb_extra_cmd_bt_tx;
    }

    return valid;
}
#endif

void WriterT::reset_all(void){
    q_cmd.clear();

    //Simon 121113
    send_finish = true;
    #if 0
    for (int i=0;i<4;i++) {
        rumble_flag[i] = false;
        prev_rumble_flag[i] = false;
    }
    #endif
    //Simon 121113

    for(int i=0; i<4; ++i) {
        reset(i);
    }
}

void WriterT::reset(int __core index){
    q_int[index].clear();
    q_aud[index].clear();
}


void WriterT::func(void){
    uint32_t k = 0;
    uint32_t c = 0;
    uint32_t pause = 0;

    while(started) {
        uint32_t ts;

        ts = GetTimeStamp5ms();

        if(k == 0) {
            k = ts;
        }else{
            if(ts - k >= 20) {
                k = ts;
                if(c > 5) {
                    pause = 2;
                }
                c = 0;

            }
        }

        if(ts != ts_last_write) {
            udata_t U;
            bool send = 0;

            ts_last_write = ts;			

            if(pause) {
                pause --;
            }else{
                if(q_cmd.get(U)) {
                    send = 1;
                }else
                if(ManagerIsBridged()) {
                    //if(merge_aud(U)) {
                    //    send = 1;
                    //}else
                    if(merge_int(U)) {
                        send = 1;
                    }
                }
    
                if(send) {
                    c++;
                    if(write_usb(&U.raw[2]) == ERR_DEVICE_ABSENT){
                        ManagerUsbDisconnect();
                        started = 0;
                    }
                }
            }

            for(int i=0; i<4; ++i) {
                if(q_int_timeout[i]) {
                    q_int_timeout[i] --;
                }
            }
        }else{
            Sleep(2);
        }
    }
}

int WriterT::write_usb(uint8_t* buffer){
    DWORD bytes;

    if(ManagerIsUsbDisconnected()) {
        return ERR_DEVICE_ABSENT;
    }

    if(WriteFile(ManagerUsbHandle(), buffer, usb_payload_size, &bytes, &overlap) == 0){
        DWORD err = GetLastError();
        if(err == ERROR_IO_PENDING){
            WaitForSingleObject(overlap.hEvent, INFINITE);
            return ERR_OK;
        }
        if((err == ERROR_HANDLE_EOF) || (err == ERROR_DEVICE_NOT_CONNECTED)){
            return ERR_DEVICE_ABSENT;
        }
        return ERR_NG1;
    }
    return ERR_OK;
}

int WriterT::write(udata_t* udata){
    if(ManagerIsUsbDisconnected()){
        return ERR_DEVICE_ABSENT;
    }

    q_cmd.put(*udata);

    return ERR_OK;
}

int WriterT::write_interrupt(int __core index, uint16_t conn_channel, const void* buffer, uint32_t size){
    uint8_t* q = &(((uint8_t*)buffer)[1]);

    if(index >= 4) {
        //dprintf("ERR_INVALID_PARAM1 ");
        return ERR_INVALID_PARAM;
    }

    if(size > 23 /* 22 + 1 (0xA2 leading) */) {
        //dprintf("ERR_INVALID_PARAM12 ");
        return ERR_INVALID_PARAM;
    }


	int wiipc_index;

	if(!MapperCoreToWiiPC(index, &wiipc_index)){
        return ERR_INVALID_INDEX;
	}

    current_connection = conn_channel;    

    if(ManagerIsBridged()) {
        #if 0
        if(q[0] == 0x18) {
            if(connected_num() == 1) {
                aud_count[index] = 2;
                q_aud[index].put(report_t(q));
            }else{
                q_aud[index].clear();
            }
        }else{
            q_int[index].put(report_t(q));
        }
        #endif

        q_int_timeout[wiipc_index] = 2;
        q_int[wiipc_index].put(report_t(q));

        return ERR_OK;
    }else{
        uevent_t  uevent;
        uparam_t* u = SetupUevent(&uevent, umajor_manager, manager_minor_ind_interrupt_data, 3, size);
        uparam_set(u[1], u8, index);
        uparam_set(u[2], u16, conn_channel);
        uparam_set_tail_str(u, (const uint8_t*)buffer, size);

        ManagerNotify(0, &uevent);
        return ERR_INVALID_STATE;
    }

}

WriterT::WriterT()
    : ThreadBaseT(true /* high_prio */, 2 /* debug id */), q_cmd(), ts_last_write() 
{
    memset(q_int_timeout, 0, sizeof(q_int_timeout));
    reset_all();
}


} /* namespace WiiPC */
