#ifndef __WIIPCWRITER_H__
#define __WIIPCWRITER_H__

#include "WiiPCThreadBase.h"
#include "QUdata.h"
#include "QReport.h"
#include "udata.h"
#include "WiiPCCommon.h"

namespace WiiPC {

struct WriterT : public ThreadBaseT {
    q_udata_t   q_cmd;
    uint32_t    ts_last_write;  /* timestamp */

    q_report_t  __wiipc q_int[4];
    q_report_t  __wiipc q_aud[4];
    int         __wiipc q_int_timeout[4];

    //Simon 121113
    bool send_finish;
    #if 0
    bool rumble_flag[4];
    bool prev_rumble_flag[4];
    #endif
    //Simon 121113

    bool __available merge_int  (udata_t& U);
    bool __available merge_aud  (udata_t& U);

    void reset      (int __core index);
    void reset_all  (void);

    void func       (void);
    int  write_usb  (uint8_t* buffer);
    int  write      (udata_t* udata);
    int  write_interrupt(int __core index, uint16_t conn_channel, const void* buffer, uint32_t size);

    WriterT();
};

} /* namespace WiiPC */

#endif /* __WIIPCWRITER_H__ */
