/*
	Debug Console
*/
#include "dconsole.h"
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>

static HANDLE hDebugConsoleOut = NULL;

extern "C" void* dget_handle(void){
	return hDebugConsoleOut;
}
//---------------------------------------------------------------------------
extern "C" void dset_window(int x, int y, int width, int height){
	HWND h = GetConsoleWindow();

	if(h){
		MoveWindow(h, x, y, width, height, TRUE);
	}
}
//---------------------------------------------------------------------------
extern "C" void dset_title(const char* title){
	SetConsoleTitle(title);
}
//---------------------------------------------------------------------------
extern "C" int dinit(const char* title){
	if(AllocConsole() == 0){
		return 1;
	}

	hDebugConsoleOut = CreateFile("CONOUT$", GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

	if(hDebugConsoleOut == NULL){
		return 2;
	}

	SetConsoleMode(hDebugConsoleOut, ENABLE_WRAP_AT_EOL_OUTPUT | ENABLE_PROCESSED_OUTPUT);

	if(title){
		dset_title(title);
	}

	return 0;
}
//---------------------------------------------------------------------------
extern "C" void dprintf(const char* format, ...){    
	#if 1
	char    cbuf[2048];
	DWORD   dwWritten;
	va_list args;

	if(hDebugConsoleOut == NULL){
		return;
	}

	va_start(args, format);
	vsprintf(cbuf, format, args);

	WriteConsole(hDebugConsoleOut, cbuf, strlen(cbuf), &dwWritten, NULL);

	va_end(args);    
	#endif
}
//---------------------------------------------------------------------------
extern "C" void dprintbuf(const void* buf, int len){
	#if 0
	int i;
	unsigned char* p;

	if(hDebugConsoleOut == NULL){
		return;
	}

	p = (unsigned char*)buf;

	for(i=0; i<len; i++){
		dprintf("%02X ", p[i]);
	}
	#endif
}
//---------------------------------------------------------------------------
extern "C" void DPrintf(const char* format, ...){
	#if 0
	char    cbuf[2048];
	DWORD   dwWritten;
	va_list args;

	if(hDebugConsoleOut == NULL){
		return;
	}

	va_start(args, format);
	vsprintf(cbuf, format, args);

	WriteConsole(hDebugConsoleOut, cbuf, strlen(cbuf), &dwWritten, NULL);

	va_end(args);
	#endif
}
//---------------------------------------------------------------------------
extern "C" void DPrintBuf(const void* buf, int len){
	#if 0
	int i;
	unsigned char* p;

	if(hDebugConsoleOut == NULL){
		return;
	}

	p = (unsigned char*)buf;

	for(i=0; i<len; i++){
		DPrintf("%02X ", p[i]);
	}
	#endif
}


