/*
    Akar CC Ltd 2012
    hidhost minors
*/
/**
    @file hidhost_minor.h
 
     
 */
#ifndef __HIDHOST_MINOR_H__
#define __HIDHOST_MINOR_H__

typedef enum{
    hidhost_minor_init_ok,
    hidhost_minor_discover_cfm_started,
    hidhost_minor_pair_ok,
    hidhost_minor_connecting,
    hidhost_minor_connected,                         /* u[1].u8 = device index, from 0 */
    hidhost_minor_dnc_ng,                            /* u[1].u8 = dnc_ng_reason */
    hidhost_minor_disconnected,                      /* u[1].u8 = device index from 0, u[2].u8 = reason */
    hidhost_minor_cfm_get_states,                    /* u[1..4].u8 = hidhost_device_state_t */

    /* not implemented yet { */
    hidhost_minor_wiimote_power_key_on,              /* u[1].u8 = device index, from 0 */
    hidhost_minor_wiimote_power_key_off,             /* u[1].u8 = device index, from 0 */
    /*                     }*/

    hidhost_minor_cmd_get_states = 0x80,             /* u[1..4].u8 = hidhost_device_state_t              */
    hidhost_minor_cmd_set_connectable,               /* u[1].boolean = is_conneable */
    hidhost_minor_cmd_set_discoverable,              /* u[1].boolean = is_discoverable */
    hidhost_minor_cmd_disconnect,                    /* u[1].u8 = device_index from 0 */
    hidhost_minor_cmd_discover_and_connect,          /* none */
    hidhost_minor_cmd_discover_and_connect2,         /* u[1].u32 = class_of_device */
    hidhost_minor_cmd_set_power_key,                 /* u[1].boolean = is_enabled */

    hidhost_minor_cmd_wiimote_set_rumble,            /* u[1].u8 = index, p[2].u8 = enable_rumble   */
    hidhost_minor_cmd_wiimote_set_leds,              /* u[1].u8 = index, p[2].u8 = leds            */

    hidhost_minor_cmd_wiimote_set_channel,           /* u[1].u8 = index, p[2].u8 = channel, params[3].u8 = continuous, params[4].u8 = ack */
    hidhost_minor_cmd_wiimote_enable_ir_clock,       /* u[1].u8 = index, p[2].u8 = enabled, params[3].u8 = ack */

    hidhost_minor_cmd_wiimote_enable_audio_clock,    /* u[1].u8 = index, p[2].u8 = enabled, params[3].u8 = ack */   
    hidhost_minor_cmd_wiimote_read_status,           /* u[1].u8 = index */
    hidhost_minor_cmd_wiimote_write_device,          /* u[1].u8 = index, p[2].u8 = device, p[3].u8 = mode, p[4].u16 = offset, p[5].str */
    hidhost_minor_cmd_wiimote_read_device,           /* u[1].u8 = index, p[2].u8 = device, p[3].u8 = mode, p[4].u16 = offset, p[5].u16 = size */          
    hidhost_minor_cmd_wiimote_write_audio,           /* u[1].u8 = index, p[2].str */
    hidhost_minor_cmd_wiimote_mute_audio,            /* u[1].u8 = index, p[2].u8 = mute, p[3].u8 = ack */
    hidhost_minor_cmd_wiimote_enable_ir,             /* u[1].u8 = index, p[2].u8 = enabled, p[3].u8 = ack */
    hidhost_minor_cmd_set_power_key_mode,            /* u[1].u8 = power_key_mode_enabled */
    hidhost_minor_cmd_raw_write,                     /* u[1].u8 = dev_index, p[2].u16 = length in bytes, [p3].tail = buffer */

    hidhost_minor_cmd_end
} hidhost_minor_enum_t;

typedef enum {
    hidhost_dnc_ng_reason_generic = 0,
    hidhost_dnc_ng_reason_discover_cfm_cannot_start,
    hidhost_dnc_ng_reason_discover_cfm_started_already,
    hidhost_dnc_ng_reason_discover_cfm_no_found,
    hidhost_dnc_ng_reason_pair_ng,
    hidhost_dnc_ng_reason_connect_ng
} hidhost_dnc_ng_reason_enum_t;

typedef enum {
    BDS_disconnected = 0,
    BDS_found_possible,
    BDS_checking_name,
    BDS_found,
    BDS_pairing,
    BDS_paired,
    BDS_connecting,
    BDS_connected,

    BDS_end
} hidhost_device_state_t;


#endif /* __HIDHOST_MINOR_H__ */
