/*
    Akar CC Ltd 2012
    Loader
*/
#ifndef __LOADER_MINOR_H__
#define __LOADER_MINOR_H__

typedef enum {
    loader_minor_nop = 0,
    loader_minor_cfm_ucore_boundary,            /* u[1].u.u32 = ucore boundary */
    loader_minor_cfm_save_start,                /* u[1].bl = OK */
    loader_minor_cfm_save_bytes,                /* u[1].bl = OK */
    loader_minor_cfm_save_verify,               /* u[1].bl = OK */
    loader_minor_cfm_copy_saved,                /* u[1].bl = OK */
    loader_minor_cfm_load_app,                  /* u[1].bl = OK */
    loader_minor_cfm_unload_app,                /* u[1].bl = OK */
                                                
    loader_minor_cfm_get_samap,                 /* u[1].tail = uint8[32] */
    loader_minor_cfm_get_guida,                 /* u[1].tail = uint8[16] */
    loader_minor_cfm_get_guidb,                 /* u[1].tail = uint8[16] */
    loader_minor_cfm_get_sbdaddr,               /* u[1].tail = uint8[6]: NAP1, NAP0, UAP, LAP2, LAP1, LAP0 */
    loader_minor_cfm_get_current_app_index,     /* u[1].u16  = app_index */
    loader_minor_cfm_set_current_app_index,     /* u[1].bl = OK */
    loader_minor_cfm_get_code1,                 /* u[1].u32 = code1 */
    loader_minor_cfm_get_code2,                 /* u[1].u32 = code2 */
    loader_minor_cfm_get_description,           /* u[1].tail = uint8[32] */
    loader_minor_cfm_find_code1,                /* u[1].u16 = app_index */

    /* UCFG Supporting */
    loader_minor_cfm_ucfg_get_num_page,         /* u[1].u16 = ucfg_num_page */
    loader_minor_cfm_ucfg_read,                 /* u[1].bl = OK, u[2].tail = uint8[32] */
    loader_minor_cfm_ucfg_get_current_page,     /* u[1].u16 = page */
    loader_minor_cfm_ucfg_set_current_page,     /* u[1].bl = OK */
    loader_minor_cfm_ucfg_get_app_current_page, /* u[1].u16 = page */
    loader_minor_cfm_ucfg_set_app_current_page, /* u[1].bl = OK */
    
    loader_minor_cfm_ucfg_save_start,           /* u[1].bl = OK */
    loader_minor_cfm_ucfg_save,                 /* u[1].bl = OK */
    loader_minor_cfm_ucfg_save_end,             /* u[1].bl = OK */
    loader_minor_ind_ucfg_saved,                /* none */

    loader_minor_cfm_samap_alloc_try,           /* u[1].bl = OK */
    loader_minor_cfm_samap_alloc_commit,        /* u[1].bl = OK */

    loader_minor_cfm_erase_app,                 /* u[1].bl = OK */

    loader_minor_cfm_switch_to_app,             /* u[1].bl = OK */	

	loader_minor_cfm_get_ir_pos,
	loader_minor_cfm_get_command,

    loader_minor_cmd_ucore_boundary = 0x80,     /* none */
    loader_minor_cmd_save_start,                /* none */
    loader_minor_cmd_save_bytes,                /* u[1].u8 = n_bytes, u[2].tail = bytes */
    loader_minor_cmd_save_verify,               /* u[1].u16 = size, u[2].u16 = crc16 */
    loader_minor_cmd_copy_saved,                /* u[1].u16 = alloc_index from 0 */

    loader_minor_cmd_load_app,                  /* u[1].u16 = app_index */
    loader_minor_cmd_unload_app,                /* none */

    loader_minor_cmd_get_samap,                 /* none */
    loader_minor_cmd_get_guida,                 /* u[1].u16 = app_index */
    loader_minor_cmd_get_guidb,                 /* none */
    loader_minor_cmd_get_sbdaddr,               /* none */
    loader_minor_cmd_get_current_app_index,     /* none */
    loader_minor_cmd_set_current_app_index,     /* u[1].u16 = app_index */
    loader_minor_cmd_get_code1,                 /* u[1].u16 = app_index */
    loader_minor_cmd_get_code2,                 /* u[1].u16 = app_index */
    loader_minor_cmd_get_description,           /* u[1].u16 = app_index */
    loader_minor_cmd_find_code1,                /* u[1].u32 = code1 */
    
    /* UCFG Supporting */
    loader_minor_cmd_ucfg_get_num_page,         /* u[1].u32 = code1 */
    loader_minor_cmd_ucfg_read,                 /* u[1].u32 = code1, u[2].u16 = page, u[3].u16 = offset, u[4].u16 = nwbuf */
    loader_minor_cmd_ucfg_get_current_page,     /* u[1].u32 = code1 */
    loader_minor_cmd_ucfg_set_current_page,     /* u[1].u32 = code1, u[2].u16 = page */
    loader_minor_cmd_ucfg_get_app_current_page, /* none */
    loader_minor_cmd_ucfg_set_app_current_page, /* u[1].u16 = page */
    loader_minor_cmd_ucfg_save_start,           /* u[1].u32 = code1, u[2].u16 = page */
    loader_minor_cmd_ucfg_save,                 /* u[1].u16 = nwlen, u[2].tail = u8[32] data to save */
    loader_minor_cmd_ucfg_save_end,             /* none */

    loader_minor_cmd_samap_alloc_try,           /* u[1].u16 = from_sector, u[2].u16 = len */
    loader_minor_cmd_samap_alloc_commit,        /* u[1].u16 = from_sector, u[2].u16 = len */
    loader_minor_cmd_erase_app,                 /* u[1].u16 = app_index */

    loader_minor_cmd_switch_to_app,             /* u[1].u32 = code1 */

	loader_minor_cmd_get_ir_pos,
	loader_minor_cmd_set_ir_pos,
	loader_minor_cmd_get_command,

    loader_minor_cmd_end
} loader_minor_enum_t;

#endif /* __LOADER_MINOR_H__ */

