#ifndef __UEVENT_H__
#define __UEVENT_H__

#include "uparam.h"

#pragma pack(push, 1)

typedef struct uevent_simple_t {
    void*           to;
    uint8_t         index;
    uint8_t         major;
    uint8_t         minor;
} uevent_simple_t;

typedef struct uevent_t {
    void*           to;
    uint8_t         index;
    uint8_t         major;
    uint8_t         minor;
    uint8_t         num_params;
    uparam_t        params[1];
} uevent_t;

/* for static uevent */
typedef struct uevent_big_t {
    void*           to;
    uint8_t         index;
    uint8_t         major;
    uint8_t         minor;
    uint8_t         num_params;
    uint8_t         raw[93];
} uevent_big_t;

typedef union uevent_union_t {
    uevent_t        head;
    uevent_big_t    big;
} uevent_union_t;

#pragma pack(pop)

#endif /* __UEVENT_H__ */

