/*
    Akar CC Ltd 2013
    Blob and Volume
*/
/* 
    BlobVolume config string:
    blob_type.volume_type::blob_config_path
 
     Examples:
    "dwbfs.wii::G:1"
    "fiso.wii::D:\\games\\xxx.iso"
    "fciso.wii::D:\\games\\xxx.ciso"
    "fgcz.wii::D:\\games\\xxx.gcz"
    "fwbfs.wii::D:\\games\\xxx.wbfs"
    "diso.wii::G:"
*/
#ifndef __BLOBVOLUME_H__
#define __BLOBVOLUME_H__

#include "TsAny.hpp"
#include "tsvolume.h"

namespace DiscIO 
{
struct TuBlobVolume {
	TsIBlobReader blob;
	TsVolume      volume;

	TuBlobVolume(): blob(), volume() {}
	TuBlobVolume(const wchar_t* _config);
	TuBlobVolume(TsIBlobReader _blob, TsVolume _volume)
		:blob(_blob), volume(_volume){}

	string  GetID(void)     { return volume->GetID(); }
	string  GetCountry(void){ return volume->GetCountry(); }
	wstring GetConfig(void);
};

typedef TsT<TuBlobVolume> TsBlobVolume;

TsBlobVolume CreateBlobVolume(const wchar_t* config);
TsBlobVolume IdentifyBlobVolume(const wchar_t* path);
} //namespace
#endif /* __BLOBVOLUME_H__ */
