/*
	Akar CC Ltd 2013
*/

#ifndef _TSVOLUME_H
#define _TSVOLUME_H

#include "Common.h"
#include "Blob.h"
#include "TsAny.hpp"

namespace DiscIO
{
typedef TsT<IBlobReader> TsIBlobReader;
struct VolumeTypeInfo {
    const char* type;
    int tag;

    VolumeTypeInfo(const char* _type, int _tag): type(_type), tag(_tag){}
};

class TuVolume;
void VolumeRegister(const VolumeTypeInfo& info, TuVolume* meta);
TuVolume* CreateVolumeByType(const char* type, TsIBlobReader reader);

class TuVolume {
public:
	string type;
	TsIBlobReader blob;

	TuVolume(): type(), blob(){}
	TuVolume(TsIBlobReader _blob) : type(), blob(_blob){}
    TuVolume(const VolumeTypeInfo& info): type(), blob(){
        VolumeRegister(info, this);
    }

	static  TuVolume* Create(TsIBlobReader _blob){
		TuVolume* instance = new TuVolume(_blob);
		instance->Identify();
		return instance;
	}

    virtual TuVolume* create(TsIBlobReader _blob){
        return Create(_blob);
    }

    virtual bool RawRead(u64 offset, u64 size, u8* buffer);
    virtual u16  RawReadBigEndian16(u64 offset, u16 def_value = 0);
    virtual u32  RawReadBigEndian32(u64 offset, u32 def_value = 0);

    virtual bool Identify(void) { return false; }
	virtual bool Read(u64 offset, u64 size, u8* buffer) { return false; }

	virtual string  GetID(void)      { return ""; }
	virtual string  GetCountry(void) { return ""; }
    virtual wstring GetTitle(void)   { return L""; }
};

typedef TsT<TuVolume> TsVolume;
}
#endif // __TSVOLUME_H__

