/*
    Akar CC Ltd 2013
*/
#ifndef __VOLUMEWII_H__
#define __VOLUMEWII_H__

#include "tsvolume.h"
#include "aes.h"

namespace DiscIO
{
class TuVolumeWii: public TuVolume {
    u8      region;
    int     discType;
    u32     numPartitions;
    u64     partitionsOffset;
    u32     partitionGroup;
    u32     volumeNum;
	u32     volumeType;
	u8      volumeKey[16];
	u64     volumeOffset;
	AES_KEY m_AES_KEY;
	bool    is_read_ready;

	TsBu8   m_buffer;
	TsBu8   m_LastDecryptedBlock;
	u64     dataOffset;
	u64     m_LastDecryptedBlockOffset;

public:
	TuVolumeWii(const VolumeTypeInfo& info): TuVolume(info){}

	static TuVolumeWii* Create(TsIBlobReader _blob){
		return new TuVolumeWii(_blob);
	}

	TuVolume* create(TsIBlobReader _blob){
    	return Create(_blob);
	}

	enum {
		DISC_TYPE_NONE = 0,
		DISC_TYPE_WII_CONTAINER,
		DISC_TYPE_WII
	};

	struct SPartition
	{
		u64 Offset;
		u32 Type;
	};

	struct SPartitionGroup
	{
		u32 numPartitions;
		u64 PartitionsOffset;
		std::vector<SPartition> PartitionsVec;
	};

	TuVolumeWii(TsIBlobReader _blob);

    bool Identify(void);
    bool Read(u64 offset, u64 size, u8* buffer);

    string  GetID(void);
    string  GetCountry(void);
};
}

#endif /* __VOLUMEWII_H__ */
